#ifndef _hash_h
#define _hash_h

#include "element.h"
#include "list.h"

struct HashTbl;
typedef struct HashTbl *HashTable;
typedef unsigned int HashIndex;

typedef HashIndex Hasher(ElementType a,int size);

char *getHashAuthor(void);

HashTable CreateHashTable(int n, Hasher F, Comparator C);
void DestroyHashTable(HashTable H);

Position FindHashEntry(HashTable H, ElementType key);
void InsertHashEntry(HashTable H, ElementType key);

ElementType GetHashEntryElement(Position P);

void PrintHashTableStatistics(HashTable H, ElementPrintLabel P);

#endif /* _hash_h */
